      subroutine cogsyn
c******************************************************************************
c     This program produces a curve-of-growth of a blended feature,
c     altering only a specified species' abundance.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'

c*****examine the parameter file
      call params

c*****set up the output files
      nwrite = 20     
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,4)
      ndump = 21               
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('output ',ndump,'formatted  ',0,nchars,6)

c*****set up the model atmosphere                                        
      filemodel = 30
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,10)
      call inmodel

c*****do the syntheses
      filelines = 31
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,12)
      call eqlib
      isynth = 1
      isorun = 1
      ncurve = 0
      iatom = int(cogatom)
      pec(iatom) = 1
      numpecatom = 1
      pecabund(iatom,1) = 0.
10    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      if (ncurve .eq. 1) then
         wstart = 10.**(rwlow)*wave1(lim1)
         wstop = 10.**(rwhigh)*wave1(lim1)
      endif
      ipr(2) = 1
      ipr(3) = 0
      if (w(ncurve) .gt. wstart) then
         pecabund(iatom,1) = pecabund(iatom,1) - rwstep
         go to 10
      endif

      pecabund(iatom,1) = rwstep
20    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      ipr(2) = 1
      ipr(3) = 0
      if (w(ncurve) .lt. wstop) then
         pecabund(iatom,1) = pecabund(iatom,1) + rwstep
         go to 20
      endif


         
c*****finish
      call finish
      end                                                                






