	program eab3
	implicit real*8 (a-h,o-z)
c
c a program which will compute the integrated-light EW of a single line,
c or in future will compute the integrated-light spectrum for a specified
c wavelength interval
c
	common/rpars/v,bv,teff,glog,mic,feh,r,frac,sigv,sw
        real*8 v(40),bv(40),teff(40),glog(40),mic(40),r(40),frac(40)
        real*8 sigv,sw,feh

	common/rlpars/wave,atom,ep,gf,ewobs
	common/clpars/id

        common/ipars/nstar,nbox
	integer nstar(40),nbox

	real*8 wave,atom,ep,gf,ewobs
        character*5 id

	real*8 wtsum,ewsum,tol,abund
	character*2 mode
	integer iatom
        logical first

c tolerance for EW match

	tol = 0.02
        first = .true.

	call init
	call read_gc_parameters (mode)

        if (mode.eq.'EW') then 

	   do nloop = 1,1000

              call read_line_info(nloop)
	      call get_start_abund(feh,atom,abund)
              iatom = nint(atom)



c loop until EW convergence

              do i = 1,20

c compute EW for each of the Nbox cmd sub-regions

                 do nmodel = 1,nbox
                    if (first) then
                       call produce_model_atmosphere(nmodel,iatom,abund) 
                       call store_model(nmodel)
                    else
		       call copy_model(nmodel,iatom,abund)
		    endif
	            call moog            !moog EW subroutine call 
                    call organize_output(nmodel)
	         enddo
                 if (first) first=.false.

                 call get_ews_and_fluxes
                 call compute_ew_weights
                 call compute_weighted_EW(ewavg)
c DEBUG
 	write(9,'(a)')'iatom,abund,ewavg,ewobs'
 	write(9,*)iatom,abund,ewavg,ewobs
c       stop
c
                 call estimate_next_abund(wave,ewavg,ewobs,abund)
   
                 if (abs((ewavg-ewobs)/ewobs) .le. tol) then
                    call output_results(nloop,ewavg,abund)
                    goto 20
                 elseif (i.ge.20) then
                    call output_noconverge
                 endif
	      enddo
 20	      continue
	   enddo

	endif
c DEBUG
c
c
c
c       elseif (mode.eq.'SS') then
c
c compute SS for each of the 40 cmd sub-regions
c
c          do nmodel = 1,40
c             call produce_model_atmosphere(nmodel,iatom,abund) 
c             call system('cmoog')                !moog SS system call 
c             call organize_output(i)
c          enddo
c          extract flux weight information from moog output files
c          extract predicted spectrum from moog output files
c          compute weights for each model 
c          compute weighted spectrum
c          write weighted spectrum
c
c       endif
c
c
	stop
	end


	subroutine init

	call system('rm -f log.output')
	call system('rm -f fort.9')

	return
	end



	subroutine read_gc_parameters(mode)
	implicit real*8 (a-h,o-z)

	common/rpars/v,bv,teff,glog,mic,feh,r,frac,sigv,sw
        real*8 v(40),bv(40),teff(40),glog(40),mic(40),r(40),frac(40)
        real*8 sigv,sw,feh

        common/ipars/nstar,nbox
	integer nstar(40),nbox

	character*80 line,mode*2

	read(5,'(a80)')line
        read(5,'(a)')line
        read(line(:2),'(a2)')mode
	read(line(3:),*)feh,nbox

c 
c just set feh to -2.0 here, for NGC 6397
c
c       feh = -2.0
c
c now read the globular cluster parameter information
c
	do i = 1,nbox
           read(5,*)v(i),bv(i),teff(i),glog(i),mic(i),r(i),frac(i),
     %              nstar(i)

c DEBUG
c       mic(i) = mic(i) -0.5
c       teff(i) = teff(i) + 200.0
c       glog(i) = glog(i) + 0.6
c
	enddo
c DEBUG
c The following was to remove the absent, top of the cmd, caused by
c small number statistics in NGC 6397.
c
c       nstar(25) = 4*nstar(25)
c       nstar(1) = 0
c       nstar(2) = 0
c       nstar(3) = 0
c       nstar(4) = 0
c       nstar(5) = 0
c       nstar(6) = 0
c       nstar(7) = 0
c       nstar(8) = 0
c       nstar(9) = 0
c       nstar(21) = 0
c       nstar(22) = 0
c       nstar(23) = 0

	return
	end




        subroutine read_line_info(nloop)
	implicit real*8 (a-h,o-z)

	common/rlpars/wave,atom,ep,gf,ewobs
	common/clpars/id

	real*8 wave,ep,gf,ewobs,atom
        character*5 id

	integer nloop
	character*80 line

c open the lines data file on the first loop

	open(unit=7,file='eab.lines',status='old')
	read(7,'(a80)')line

	open(unit=8,file='INPUT')
	write(8,'(a80)')line
       
        do i = 1,nloop
	   read(7,'(a80)',end=900)line
	enddo
	write(8,'(a80)')line
        close(unit=8)


	read(line(6:),*)wave,atom,ep,gf,ewobs
        read(line(:5),'(a5)')id

	rewind(unit=7)
	close(unit=7)

	return

 900	continue
	stop

	return
	end




        subroutine organize_output(imodel)
	implicit real*8 (a-h,o-z)
c 
c this routine will move the MOOG output files 
c
	integer imodel
	character*30 cmd1,cmd2

	cmd1 = 'cp OUTPUT output.'
	cmd2 = 'cp logfile log.'
	if (imodel.le.9) then
	    write(cmd1(18:18),'(i1)')imodel
	    write(cmd2(16:16),'(i1)')imodel
	elseif (imodel.ge.10) then
	    write(cmd1(18:19),'(i2)')imodel
	    write(cmd2(16:17),'(i2)')imodel
	endif
	call system(cmd1)
	call system(cmd2)
	return
	end





        subroutine compute_weighted_EW(ewavg)
	implicit real*8 (a-h,o-z)

        common/rline/ew,cflux,wt
        real*8 ew(40),cflux(40),wt(40)

        common/ipars/nstar,nbox
	integer nstar(40),nbox

	real*8 ewavg,wtsum,ewsum

	ewsum = 0.0
	wtsum = 0.0

	do i = 1,nbox
	   ewsum = ewsum + ew(i)*wt(i)
           wtsum = wtsum + wt(i)
	enddo
c DEBUG
c       write(6,'(a)')'i,   EW(i),  frac_EW'
cdo i = 1,40
c   few = ew(i)*wt(i)/wtsum
c   write(6,*)i,ew(i),few
cenddo
	ewavg = ewsum/wtsum
	return
	end




        subroutine estimate_next_abund(wave,ewcalc,ewobs,abund)
	implicit real*8 (a-h,o-z)

	real*8 wave,ewavg,ewobs,abund,ratio,rwlcomp,rwlgobs

c
c based on Moog's convergence code for Abfind
c
        ratio = ewobs/ewcalc
        rwlcomp = dlog10(ewcalc/wave) - 3.0
        rwlgobs = dlog10(ewobs/wave) - 3.0
        if (rwlcomp.lt.-5.2 .and. rwlgobs.lt.-5.2) then
           ratio = ratio
        elseif (rwlcomp.ge.-5.2 .and. rwlgobs.ge.-5.2) then
           ratio = ratio**2.0
        else
           ratio = ratio**1.5
        endif
	abund = abund+dlog10(ratio)

	return
	end





        subroutine produce_model_atmosphere(nmodel,iatom,abund) 
	implicit real*8 (a-h,o-z)

	common/rpars/v,bv,teff,glog,mic,feh,r,frac,sigv,sw
        real*8 v(40),bv(40),teff(40),glog(40),mic(40),r(40),frac(40)
        real*8 sigv,sw,feh

	real*8 abund
	integer iatom,nmodel

	i = nmodel

        call make_kurucz(teff(i),glog(i),feh,mic(i),iatom,abund)

	return
	end




        subroutine store_model(nmodel)

	integer nmodel
	character*16 cmd

        cmd = 'cp MODEL MODEL? '

c write the model number into the system command line

        if (nmodel.lt.10) then
           write(cmd(15:15),'(i1)')nmodel
        elseif (nmodel.ge.10 .and. nmodel.lt.100) then
           write(cmd(15:16),'(i2)')nmodel
	else
           write(6,*)'Error: more than 99 cmd regions'
           stop
	endif

c call system command

	call system(cmd)

	return
	end




        subroutine copy_model(nmodel,iatom,abund)

	integer nmodel,iatom
        real*8 abund
	character*7 fname,line*80

	
c open the appropriate model files

        open(unit=10,file='MODEL')
	fname ='MODEL  '

        if (nmodel .lt. 10) then
           write(fname(6:6),'(i1)')nmodel
           open(unit=9,file=fname(:6),status='old')
        elseif (nmodel.lt.100 .and. nmodel.ge.10) then
           write(fname(6:7),'(i2)')nmodel
           open(unit=9,file=fname(:7),status='old')
        else
           write(6,*)'Error: more than 99 cmd regions'
           stop
 	endif


c Copy to file MODEL.  
c When 'NATOMS' is found change the abundance on the next line

	do i = 1,1000
	   read(9,'(a)',end=900)line
	   write(10,'(a)')line
	   if (line(:6).eq.'NATOMS') then
	      read(9,'(a)',end=900)line
              write(line(:10),'(i10)')iatom
              write(line(20:26),'(f7.4)')abund
	      write(10,'(a)')line
           endif
	enddo
 900	continue
	close(unit=9)
	close(unit=10)
	return
	end





        subroutine get_ews_and_fluxes
	implicit real*8 (a-h,o-z)

        common/rline/ew,cflux,wt
        real*8 ew(40),cflux(40),wt(40)

        common/ipars/nstar,nbox
	integer nstar(40),nbox

	character*80 line,fname*30

        fname = 'output.1'

	do i = 1,nbox
           if (i.lt.10) then
              write(fname(8:8),'(i1)')i
	   else
              write(fname(8:9),'(i2)')i
	   endif
	   open(unit=17,file=fname,status='old')
c
c read the 6 header lines and the line containing EW and continuum flux
c
	   do j = 1,7
	      read(17,'(a80)')line
	   enddo

c read ew and flux

           read(line(53:75),*)ew(i),cflux(i)

	   close(unit=17)
	enddo
	return
	end







        subroutine compute_ew_weights
	implicit real*8 (a-h,o-z)

	common/rpars/v,bv,teff,glog,mic,feh,r,frac,sigv,sw
        real*8 v(40),bv(40),teff(40),glog(40),mic(40),r(40),frac(40)
        real*8 sigv,sw,feh

        common/ipars/nstar,nbox
	integer nstar(40),nbox

        common/rline/ew,cflux,wt
        real*8 ew(40),cflux(40),wt(40)

        wtsum = 0.0
	do i = 1,nbox
	   wt(i) = cflux(i) * r(i)**2 * dble(nstar(i))
c DEBUG
c          wt(i) = frac(i)
           wtsum = wtsum + wt(i)
c

	enddo
c DEBUG
c
	do i = 1,nbox
	   wt(i) = wt(i)/wtsum
	enddo
c

	
	return
	end




        subroutine output_results(nloop,ewavg,abund)
	implicit real*8 (a-h,o-z)

	common/rlpars/wave,atom,ep,gf,ewobs
	common/clpars/id

	real*8 wave,ep,gf,ewobs,atom
        character*5 id

        common/ipars/nstar,nbox
	integer nstar(40),nbox

c DEBUG
        common/rline/ew,cflux,wt
        real*8 ew(40),cflux(40),wt(40)
c


	real*8 ewavg,abund
	integer iatom,nloop

	if (nloop.eq.1) write(6,100)

        write(6,'(a5,f10.3,2f8.3,f7.1,2f8.3)')id,wave,ep,gf,ewobs,abund
     %     ,ewavg

c DEBUG
	if (nloop.eq.1) write(9,100)
        write(9,'(a5,f10.3,2f8.3,f7.1,f8.3)')id,wave,ep,gf,ewobs,abund
        write(9,'(a)')'  I      EW(I)     WT(I)   EW(I)*WT(I)'
	do i = 1,nbox
	   write(9,'(i5,2x,3f10.6)')i,ew(i),wt(i),ew(i)*wt(i)
	enddo
c
	call system('cat fort.9 >>log.output')

 100	format(' ID   Wavelength    EP      GF   EWobs  Abund  EWcalc',/)
	return
	end




        subroutine output_noconverge
	implicit real*8 (a-h,o-z)

	common/rlpars/wave,atom,ep,gf,ewobs
	common/clpars/id

	real*8 wave,ep,gf,ewobs,atom
        character*5 id

        write(6,*)'>>>Warning: line ',id,' at ',wave,' did not converge'
	return
	end





	subroutine get_start_abund(feh,atom,abund)

c A routine to get the start abundance value, from [Fe/H]

c
c SAD set to the meteoritic values from the most recent Grevesse compilation
c (1996?)
c
      real*8 xabu(95),feh,atom,abund

      data xabu/
     * 12.00,10.99, 3.31, 1.42, 2.79, 8.55, 7.97, 8.87, 4.48, 8.08,      
     1  6.32, 7.58, 6.49, 7.56, 5.53, 7.20, 5.28, 6.52, 5.13, 6.35,      
     2  3.10, 4.94, 4.02, 5.69, 5.53, 7.50, 4.91, 6.25, 4.29, 4.67,      
     3  3.13, 3.63, 2.37, 3.38, 2.63, 3.23, 2.41, 2.92, 2.23, 2.61,      
     4  1.40, 1.97, 0.00, 1.83, 1.10, 1.70, 1.24, 1.76, 0.82, 2.14,      
     5  1.03, 2.24, 1.51, 2.23, 1.13, 2.22, 1.22, 1.63, 0.80, 1.49,      
     6  0.00, 0.98, 0.55, 1.09, 0.35, 1.17, 0.51, 0.97, 0.15, 0.96,      
     7  0.13, 0.75,-0.13, 0.69, 0.28, 1.39, 1.37, 1.69, 0.87, 1.17,      
     8  0.83, 2.06, 0.71, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.09,      
     9  0.00, -0.50, 3*0.0/

      iatom = nint(atom)
      abund = xabu(iatom) + feh
      return
      end
