
      subroutine oneline (imode)                                    
c******************************************************************************
c     This routine computes a single line profile                       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      include 'Pstuff.com'
      real*8 dinteg(200)
      data wavl/0.0/                                   

c AMcW 8/2003 for moog subroutine mode
      wavl = 0.0
c


c*****set an arbitrary maximum # of wavelength points to compute 
c     the line profile
      maxsteps = 75


c*****get started; calculate the step size
      if (imode .eq. 0) gf1(ncurve) = gf(lim1)                          
      dellam(1) = 0.                                                    
      if (wavestep .eq. 0.) then
         st1 = wave1(lim1)*dopp(lim1,jtau5)/2.997929e10/5.                 
         st1 = dble(int(10000.*st1))/10000.                              
      else
         st1 = wavestep
      endif


c*****calculate the continuous opacity at line wavelength               
      wave = wave1(lim1)                                                
      if (abs(wave-wavl) .gt. 30.) then
         wavl = wave
         call opacit(2,wave)     
         if (imode .ne. 2 ) call out(15)                        


c*****calculate continuum intensity/flux                                
         call cdcalc(1)                                                    
         first = 0.4343*cd(1)
         flux = rinteg(xref,cd,dummy1,ntau,first)
         if (imode .ne. 2) call out(10)         
      endif
      cflux(lim1) = flux
             

c*****recheck the wavelength step size
      if (wavestep .eq. 0.) then
140      wave = wave1(lim1)
         call taukap
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(1) = rinteg(xref,cd,dummy1,ntau,first)
         wave = wave + 5.*st1
         call taukap
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(2) = rinteg(xref,cd,dummy1,ntau,first)       
         if (d(2)/d(1) .lt. 0.7) then
            st1 = st1/1.5
            st1 = dfloat(int(10000.*st1))/10000.                              
            go to 140
         elseif (d(2)/d(1) .gt. 0.85) then
            st1 = st1*2.0
            st1 = dfloat(int(10000.*st1))/10000.                              
            go to 140
         endif
      endif
      wave = wave1(lim1)                                                
      if (imode .ne. 2) call out(2)    


c*****calculate wavelength dependent line quantities, and the line depth
c     until the depth is very small in the line wing
      do n=1,maxsteps
         call taukap                                                       
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(n) = rinteg(xref,cd,dummy1,ntau,first)       
         if (ipr(3).ge.3 .and. n.eq.1) call out (22)
         if (ipr(6).ne.0 .and. imode.ne.2) call out (19)  
         if (d(n)/d(1) .lt. 0.0075) then
            ndepths = n
            go to 160
         endif
         dellam(n+1) = dellam(n) + st1                                    
         wave = wave1(lim1) + dellam(n+1)                                  
      enddo                                                             
      if (imode .ne. 2) call out (16)
      ndepths = maxsteps 


c*****finish the calculation                                            
160   if (imode .ne. 2) call out (17)                                       
      do n=2,ndepths
         d(ndepths+n-1) = d(n)
      enddo
      d(ndepths) = d(1)
      do n=2,ndepths
         d(n-1) = d(2*ndepths+1-n)
      enddo
      dellam(1) = -st1*(ndepths-1)
      ndep = 2*ndepths - 1
      do n=2,ndep
         dellam(n) = dellam(n-1) + st1
      enddo
      first = 2*dellam(ndep)*d(ndep)
      w(ncurve) = rinteg(dellam,d,dinteg,ndep,first) 
      if (imode .ne. 2) call out(14)                        
 
 
      return                                                            
      end                                                               


