
      subroutine out (number)                                             
c******************************************************************************
c     This routine is a printing subroutine                                 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Dummy.com'
      include 'Factor.com'
      include 'Pstuff.com'
      include 'Quants.com'
      character molname*8,name*1,parent*8,ion*4
      real*8 dd(5000)
      data n,num,ifresh/3*0/                                                    

c*****go to the appropriate output area
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,
     .       18,19,20,21,22,23,24,25,26,27,28,29),number  

c*****here is the model atmosphere output; all drivers
1     if (ipr(1) .lt. 1) return                                           
      write (nwrite,107) moditle
107   format (/'MODEL ATMOSPHERE HEADER:'/a80/)
      do i=1,ntau                                                    
         dummy1(i) = dlog10(pgas(i))                                        
         dummy2(i) = dlog10(ne(i)*1.38054d-16*t(i))                         
      enddo
      write (nwrite,101) wavref,(i,xref(i),tauref(i),t(i),dummy1(i),      
     .      pgas(i),dummy2(i),ne(i),vturb(i),i=1,ntau)                        
101   format ('INPUT ATMOSPHERE QUANTITIES',10x,                      
     .        '(reference wavelength =',f10.2,')'/3x,'i',2x,'xref',3x,
     .        'tauref',7x,'T',6x,'logPg',4x,'Pgas',6x,'logPe',
     .        5x,'Ne',9x,'Vturb'/ 
     .        (i4,0pf6.2,1pe12.5,0pf9.1,f8.3,1pe11.4,0pf8.3,
     .        1pe11.4,e11.2))       
      write (nwrite,102)                                                  
102   format (/'INPUT ABUNDANCES: (log10 number densities, log H=12)'/
     .       '      Default solar abundances: Anders and Grevesse 1989')
      do i=1,95                                                      
         dummy1(i) = dlog10(xabund(i)) + 12.0                               
      enddo
      write (nwrite,104) (names(i),i,dummy1(i),i=1,95)                     
104   format (5(3x,a2,'(',i2,')=',f5.2))                                      
      write (nwrite,106) (ipr(i),i=1,4)                                  
106   format (/'OPTIONS: atmosphere = ',i1,5x,'molecules  = ',i1/
     .        '         lines      = ',i1,5x,'flux/int   = ',i1)
      return                                                             

c*****here is the calculated wavelength step size; single-line computations
2     write (nwrite,201) lim1,st1
201   format (/'LINE NUMBER',i5,10x,'wavelength step size =',f7.4)
      return   
                                                          
c*****here are the line data; all drivers
3     if(ipr(3) .lt. 1) return                                           
      write (nwrite,311) nlines
311   format (/'INPUT LINES DATA FOR',i4,' LINES'/' j ',4x,'wave1',
     .       7x,'species',8x,'E.P.',5x,'gf',8x,'C6',
     .       5x,'strength',6x,'E.W.')
      do j=1,nlines
         ich = idint(charge(j) + 0.1)
         if (ich .eq. 1) then 
            ion = ' I  '
         elseif (ich .eq. 2) then
            ion = ' II '
         elseif (ich .eq. 3) then
            ion = ' III'
         endif
         iatom = idint(atom1(j))
         if (iatom .lt. 100) then
            if (iunits .eq. 1) then
               write (nwrite,313) j,1.d-4*wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            else if(iunits .eq. 2) then
               write (nwrite,312) j,1.d8/wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            else
               write (nwrite,312) j,wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            endif
312         format (i3,f10.3,3x,a2,a4,2f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
313         format (i3,f10.6,3x,a2,a4,2f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
         else
            call sunder (atom1(j),ia,ib)
            if (ia .eq. 1) then
               l = ia
               ia = ib
               ib = l
            endif
            leftovr = idint(10000.*(atom1(j)-iatom)+0.1)
            if (ia .lt. 10) then
               read (names(ia),345) name
345            format (a1)
               write (molname,343) name,names(ib),leftovr
343            format (1x,a1,a2,i4)
            else
               write (molname,341) names(ia),names(ib),leftovr
341            format (2a2,i4)
            endif
            if (iunits .eq. 1) then
               write (nwrite,344) j,1.d-4*wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            else if (iunits .eq. 2) then
               write (nwrite,342) j,1.d8/wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            else
               write (nwrite,342) j,wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            endif
342         format (i3,f10.3,2x,a8,f7.1,f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
344         format (i3,f10.6,2x,a8,f7.1,f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
         endif
      enddo    
      if (start .eq. 0.0 .and. stop .eq. 0.0) go to 304
      if (iunits .eq. 2) then
         write (nwrite,303) oldstart,oldstop,oldstep,olddelta
      elseif (iunits .eq. 1) then
         write (nwrite,305) oldstart,oldstop,oldstep,olddelta
      else 
         write (nwrite,306) start,stop,step,delta  
      endif
303   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=1/cm)'/
     .      10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .      'step size in the spectrum =',f11.4,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f11.4,' of the point')          
305   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=microns)'/
     .      10x,'start =',f10.7,' ',5x,'stop =',f10.7,' '/  
     .      'step size in the spectrum =',f10.7,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f10.7,' of the point')          
306   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=A)'/
     .      10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .      'step size in the spectrum =',f11.4,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f11.4,' of the point')          

304   if (rwlow .ne. 0.) then
         write (nwrite,333) rwlow, rwhigh, rwstep
333      format (/'CURVE-OF-GROWTH PARAMETERS'/
     .           10x,'log(R.W) lower bound =',f7.3,
     .           10x,'upper bound =',f7.3/
     .           10x,'step size in the curve =',f7.3)
      endif  

      if(ipr(3) .lt. 4) go to 4

9     write (nwrite,901)                                                  
901   format (/'PARTITION FUNCTIONS')                                      
      do j=1,95
         if (elem(j) .ne. 0.) then
            iatom = int(elem(j))
            write (nwrite,903) iatom, names(iatom), xam(j),
     .                         xchi1(j), xchi2(j), xchi3(j)
903         format (/'Z =',i2,' (',a2,'),  mass=',f8.3,'  I.P.s=',
     .              3f7.3)
            do k=1,4
               write (nwrite,904) k-1,(u(j,k,i),i=1,ntau)   
904            format ('    ionization state = ',i1/(10f8.3))  
            enddo
         endif
      enddo
      return                                                             

4     if (ipr(3) .lt. 2) return                                           
      write (nwrite,401)                                                  
401   format (/'LINE OPACITIES AT LINE CENTERS')                          
      do j=1,nlines                                                  
         write (nwrite,403) j,(kapnu0(j,i),i=1,ntau)                         
403      format (10h0  kapnu0(,i3,3h,i)/(8(1pe10.2)))                        
      enddo
      return                                                             

5     write (nwrite,501) (amol(i),(const(j,i),j=1,6),i=1,nmol)            
501   format (/'INPUT EQUILIBRIUM DATA:'/1x,'species',3x,'const1',       
     1 3x,'const2',6x,'const3',6x,'const4',6x,'const5',6x,'const6'/      
     2 (0pf8.1,f8.3,1p5e12.4))                                         
      return                                                             

6     do 602 i=1,neq                                                     
602   dummy1(i) = iorder(i)                                              
      write (nwrite,601) (dummy1(i),i=1,neq),(amol(i),i=1,nmol)           
601   format (/'MOLECULAR EQUILIBRIUM SOLUTIONS:  (log partial',
     .       ' pressures listed under names)'/                    
     .       2x,'i',5x,'T',6x,'Pgas',6f10.1/(19x,6f10.1))               
      return                                        
                     
7     pglog = dlog10(pgas(lev))
      write (nwrite,701) lev,t(lev),pglog,(xatom(i),i=1,neq),         
     .                   (xmol(i),i=1,nmol)        
701   format (i3,f8.0,f8.2,6f10.2/(19x,6f10.2))                   
      return                                                             

8     if (ipr(1) .lt. 1) return                                           
      write (nwrite,801) (kapref(i),i=1,ntau)                             
801   format (/'KAPREF ARRAY:'/(6(1pe12.5)))                  
      return                                                             

10    if (iunits .eq. 2) then 
         write (nwrite,1001) 1d8/wave,flux                     
      else if (iunits .eq. 1) then 
         write (nwrite,1002) wave/1d4,flux
      else 
         write (nwrite,1001) wave,flux
      endif
1001  format ('AT WAVELENGTH/FREQUENCY =',f11.3,
     .        '  CONTINUUM FLUX/INTENSITY =',1pe12.5)
1002  format ('AT WAVELENGTH/FREQUENCY =',f11.7,
     .        '  CONTINUUM FLUX/INTENSITY =',1pe12.5)
      return

11    write (nwrite,1101)                                                 
1101  format (/'SPECTRUM DEPTHS')                                      
      if (ndump .eq. 0) return                                           
      write (ndump,1805) moditle
      if (iraf .eq. 1) then
         npoint = (stop-start)/step
         write (n2write,1104) npoint,wave,wave,step,step
1104     format ('SIMPLE  =    t'/'NAXIS   =     1'/'NAXIS1  = ',i10,/
     .   'W0      =',f10.4/'CRVAL1  =',f10.4/'WPC     =',f10.4/
     .   'CDELT1  =',f10.4)
         write (n2write,1105) 
1105     format (16HORIGIN  = 'moog'/21HDATA-TYP= 'synthetic'/
     .           18HCTYPE1  = 'lambda'/21HCUNIT1  = 'angstroms')
         write (n2write,1106) moditle
1106     format (11HTITLE   = ',A65,1H')
         do j=1,93
            if (pec(j) .gt. 0 ) then
               dummy1(j) = dlog10(xabund(j)) + 12.0
               write (n2write,1107) names(j),dummy1(j)
1107           format ('ATOM    = ',1H',7x,a2,1H',/,'ABUND   = ',f10.2)
            endif
         enddo
         write (n2write,1108) vturb(1)
1108     format ('VTURB   = ',e10.4,'     /  cm/sec  ')
         write (n2write,1109)
1109     format ('END')
      endif
      if (iunits .eq. 2) then
         write (ndump,1102) oldstart,oldstop,oldstep,olddelta
      elseif (iunits .eq. 1) then
         write (ndump,1103) oldstart,oldstop,oldstep,olddelta
      else 
         write (ndump,1102) start,stop,step,delta  
      endif
1102  format (4f11.3)                                                     
1103  format (4f10.7)                                                     
      return                                                             

12    n = n + 1                                                          
      if (n .lt. 10) return    
      if (iraf .eq. 1) then
         do j=1,10
            dd(num+j) = 1. - d(num+j)
         enddo
         write (n2write,1202) (dd(num+j),j=1,10)
1202     format (10f7.4)            
      endif
      if (iunits .eq. 2) then
         wave3 = 1.d8/wave + 9.0*oldstep 
         write (nwrite,1203) wave3,(d(num+j),j=1,10)                         
      else if (iunits .eq. 1) then
         wave3 = 1.d-4*(wave - 9.0*step)
         write (nwrite,1201) wave3,(d(num+j),j=1,10)                         
      else 
         wave3 = wave - 9.0*step
         write (nwrite,1203) wave3,(d(num+j),j=1,10)                         
      endif
1201  format (f10.7,': depths=',10f6.3)                       
1203  format (f10.3,': depths=',10f6.3)                       
      if(ndump .gt. 0) write (ndump,1202) (d(num+j),j=1,10)              
      n = 0                                                              
      num = num + 10                                                     
      if (num .ge. 5000) num = 0                                          
      return                                                             

13    if(n .eq. 0) go to 1301                                            
      if (iraf .eq. 1) then
         do j=1,10
            dd(num+j) = 1. - d(num+j)
         enddo
         write (n2write,1202) (dd(num+j),j=1,n)
      endif
      if (iunits .eq. 2) then
         wave3 = 1.d8/wave + 9.0*oldstep 
         write (nwrite,1203) wave3,(d(num+j),j=1,n)                         
      else if (iunits .eq. 1) then
         wave3 = 1.d-4*(wave - 9.0*step)
         write (nwrite,1201) wave3,(d(num+j),j=1,n)                         
      else 
         wave3 = wave - 9.0*step
         write (nwrite,1203) wave3,(d(num+j),j=1,n)                         
      endif
      if (ndump .gt. 0) write(ndump,1202) (d(num+j),j=1,n)               
1301  if (iunits .eq. 2) then
         write (nwrite,1302) 1.d8/wave
      elseif (iunits .eq. 1) then
         write (nwrite,1304) 1.d-4*wave
      else
         write (nwrite,1302) wave
      endif
1302  format ('FINAL WAVELENGTH/FREQUENCY =',f10.3/) 
1304  format ('FINAL WAVELENGTH/FREQUENCY =',f10.7/)
      num = 0                                                        
      n = num 
      return                                                             

14    ew = 1000.0*w(ncurve)
      gflog = dlog10(gf1(ncurve))                                        
      rwlog = dlog10(w(ncurve)/wave1(lim1))                          
      write (nwrite,1401) wave1(lim1),ew,rwlog,gf1(ncurve),gflog      
1401  format('lambda =',f12.3,5x,'E.W. =',f8.1,' mA.',5x,
     .       'log(R.W.) =',f6.2/'gf =',1pe10.3,5x,'log(gf) =',
     .       0pf7.2)                      
      return                                                             

15    if (ipr(1) .lt. 2) return                                           
      write(nwrite,1501) wave,(kaplam(i),i=1,ntau)                       
1501  format('  kaplam from 1 to ntau at wavelength',f10.2/            
     1 (6(1pe12.5)))                                                     
      return                                                             

16    write (nwrite,1601)
1601  format ('WARNING:  not enough points to specify the line?')
      return                                                             

17    write (nwrite,1701) (d(j),j=1,ndepths)                     
1701  format (10f7.3)
      return                                                             

18    if (ndump .ne. 0 .and. lim1 .eq. 1) 
     .   write (ndump,1805) moditle
1805  format (a80)                                                       
      do 1801 i=1,ncurve                                                 
      w(i) = dlog10(w(i)/wave1(lim1))
1801  gf1(i) = dlog10(gf1(i))                                            
      iatom = atom1(lim1)                                                
      if(iatom .ge. 100) iatom = 1                                       
      abund = dlog10(xabund(iatom)) + 12.                                
      write (nwrite,1803) wave1(lim1),atom1(lim1),e(lim1,1),
     .                    abund,ncurve  
1803  format(/'wavelength =',f8.2,5x,'species =',f6.1,5x,'ep =',f6.2/,
     1 'abundance =',f9.2,5x,'n =',i2)                                      
      write (nwrite,1802) (gf1(i),w(i),i=1,ncurve)                        
1802  format('  curve of growth in (loggf,logrw) pairs'/                 
     1 (5('  (',f5.2,',',f5.2,')')))                                     
      if (ndump .eq. 0) return                                           
      write (ndump,1803) wave1(lim1),atom1(lim1),e(lim1,1),
     .       abund,ncurve   
      write (ndump,1804) (gf1(i),w(i),i=1,ncurve)                         
1804  format (12f6.2)                                                     
      return                                                             

19    do 1901 i=1,ntau                                                   
      if(taunu(i)+taulam(i) .ge. 1.) go to 1902                          
1901  continue                                                           
1902  write(nwrite,1903) i,taunu(i),taulam(i)                            
1903  format('  tau(total) is greater than 1 at level',i3,               
     1 '  optical depths are taunu =',e12.3,'  and taulam =',e12.3)       
      return                               

20    write (nwrite,2002)
      xmetals = abscale + pecabund(99,isynth)
2002  format (/'For these computations, some abundances have ',
     .       ' been altered:')
      write (nwrite,2007) xmetals
2007  format (' ALL abundances NOT listed below differ ',
     .        'from solar by ',f6.2,' dex')
      if (.not.curt) write (ndump,2007) xmetals
      do 2001 j=1,93
         if (pec(j) .gt. 0 ) then
            dummy1(j) = dlog10(xabund(j)) + 12.0         
            write (nwrite,2003) names(j),dummy1(j)
2003        format (8x,'element ',a2,':  abundance = ',f5.2)
            write (ndump,2003) names(j),dummy1(j)
         endif
2001     continue
      return            

21    write (nwrite,2102) modtype
2102  format (13('-'),'MOOG OUTPUT FILE',10('-'),
     .        '(MOOG version from 3/09/95)',13('-')//
     .        'THE MODEL TYPE: ',a10)
      if (modtype .eq. 'begn      ' .or.
     .    modtype .eq. 'BEGN      ') write (nwrite,2103)
2103  format ('   The Rosseland opacities and optical depths have ',
     .        'been read in')
      return

22    do i=1,ntau                                                   
         cd(i) = dabs(cd(i)) 
         dummy1(i) = xref(i)*cd(i)
      enddo
      first = 0.
      xmean = rinteg(xref,dummy1,dummy2,ntau,first)/
     .        rinteg(xref,cd,dummy2,ntau,first) 
c
c now write-out the contribution function elements
c
      write (nwrite,'(a)') 'TAUNU(I)'
      write (nwrite,*) (taunu(i),i=1,ntau)
      write (nwrite,'(//)')
c
      write (nwrite,2205) xmean                                           
2205  format (/' mean level of line depth formation, log(tauref) = ',
     .       f6.2)                                                            
      do i=1,ntau
         if (taulam(i)+taunu(i) .ge. 1.) then
            write (nwrite,2206) xref(i)
2206        format (' log(tauref) for [taulam+taunu>=1] is ',
     .              f6.2)
            return
         endif
      enddo

23    return

24    if (ncurve .ne. 1) then
         write (nwrite,2402) ncurve
2402     format (' This fit required ',i2,' iterations')
      endif
      return

25    if(ifresh .eq.0) then
         write (ndump,2511) obsitle,moditle
2511     format (a80)
c AMcW 8/2003
c        ifresh = 1
      endif
      if (cogatom .eq. 0.) then
         iatom = idint(atom1(lim1obs))
      else
         iatom = idint(cogatom)
      endif
      xab = dlog10(xabund(iatom)) + 12.
      ich = idint(charge(lim1obs) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      if (iatom .lt. 100) then
         write (array,2504) names(iatom),ion,xab
2504     format ( 'Abundance Results for Species ',a2,a4,
     .        '       (input abundance = ',f6.2,')')
         line = 1
         call prinfo (line)
         write (ndump,*)
         write (ndump,2504) names(iatom),ion,xab
         write (array,2514)
2514     format ('wavelength        EP     logGF        EW',
     .        '     logRW     abund     del avg')
         line = 2
         call prinfo (line)
         write (ndump,2514)
      else
         call sunder (atom1(j),ia,ib)
         if (ia .eq. 1) then
            l = ia
            ia = ib
            ib = l
         endif
         leftovr = idint(10000.*(atom1(j)-iatom)+0.1)
         if (ia .lt. 10) then
            read (names(ia),345) name
            write (molname,343) name,names(ib),leftovr
         else
            write (molname,341) names(ia),names(ib),leftovr
         endif
         write (array,2506) molname,xab
2506     format ( 'Abundance Results for Species ',a8,
     .        '       (input abundance = ',f6.2,')')
         line = 1
         call prinfo (line)
         write (ndump,*)
         write (ndump,2506) molname,xab
         write (array,2516)
2516     format('wavelength        EP     logGF      EWin',
     .        '    EWcalc     abund     del avg')
         line = 2
         call prinfo (line)
         write (ndump,2516)
      endif
      do 2510 l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            diff = abunout(l) - average
         else
            diff = 999.99
         endif
         ew = 1000.*width(l)
         rw = dlog10(width(l)/wave1(l))
         write (array,2501) wave1(l),e(l,1),dlog10(gf(l)), 
     .         ew,rw,abunout(l),diff
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2501) wave1(l),e(l,1),dlog10(gf(l)), 
     .         ew,rw,abunout(l),diff
2501     format (f10.2,f10.2,f10.3,f10.1,2f10.2,f12.2)
2510  continue
      write (array,2505) average, deviate, kount
      line = line + 1
      if (errmess(1:9) .ne. 'stopinfo!') call prinfo (line)
      write (ndump,2505) average, deviate, kount
2505  format ('average abundance = ',f5.2,'     std. ',
     .     'deviation = ',f5.2,'     #lines = ',i3)
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         write (array,2507) xxm1, xxb1, xxr1 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2507) xxm1, xxb1, xxr1
2507     format ('E.P. correlation:  slope = ',f7.3,'  intercept = ',
     .           f7.3,'  corr. coeff. = ',f7.3)
      else
         write (array,*) 'No statistics done for E.P. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,*) 'No statistics done for E.P. trends' 
      endif
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         write (array,2508) xxm2, xxb2, xxr2   
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2508) xxm2, xxb2, xxr2   
2508     format ('R.W. correlation:  slope = ',f7.3,'  intercept = ',
     .           f7.3,'  corr. coeff. = ',f7.3)
      else
         write (array,*) 'No statistics done for R.W. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,*) 'No statistics done for R.W. trends' 
      endif
      return

26    write (nwrite,*) 'Isotopic Ratios given for this synthesis'
      do 261 i=1,numiso
      iiso=isotope(i)
      call sunder (isotope(i),ia,ib)
      if (ia .eq. 1) then
         l = ia
         ia = ib
         ib = l
      endif
      leftovr = idint(10000.*(isotope(i)-iiso)+0.1)
      if (ia .lt. 10) then
         read (names(ia),2645) name
2645     format (a1)
         write (molname,2643) name,names(ib),leftovr
2643     format (1x,a1,a2,i4)
      else
         write (molname,2641) names(ia),names(ib),leftovr
2641     format (2a2,i4)
      endif
      if (ia .lt. 10) then
         write (parent,2642) names(ia),names(ib) 
2642     format (a1,a2) 
      else 
         write(parent,2644) names(ia),names(ib)
2644     format (2a2)
      endif
      write (nwrite,2601) parent,molname,isoabund(i,isorun)
      write (ndump,2601) parent,molname,isoabund(i,isorun)
2601  format ('Isotope Ratio: ',a4,'/',a10,' = ',f10.3)
261   continue
      return

 27   write (nwrite,2711) nstrong
2711   format (/'INPUT LINES DATA FOR',i4,' STRONG LINES'/' j ',4x,
     .       'wave1',7x,'species',8x,'E.P.',6x,'gf',9x,'C6',
     .       6x,'strength')
      do 2710 j=1,nstrong
      ich = idint(scharge(j) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      iatom = idint(satom1(j))
      if (iatom .lt. 100) then
         if (iunits .eq. 1) then
            write (nwrite,2713) j,1.d-4*swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else if(iunits .eq. 2) then
            write (nwrite,2712) j,1.d8/swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else
            write (nwrite,2712) j,swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         endif
2712      format (i3,f10.3,3x,a2,a4,2f8.2,1pe11.3,e11.3,e11.2)             
 2713     format (i3,f10.6,3x,a2,a4,2f8.2,1pe11.3,e11.3,e11.2)             
      else
         call sunder (satom1(j),ia,ib)
         if (ia .eq. 1) then
            l = ia
            ia = ib
            ib = l
         endif
         leftovr = idint(10000.*(satom1(j)-iatom)+0.1)
         if (ia .lt. 10) then
            read (names(ia),2745) name
2745         format (a1)
            write (molname,2743) name,names(ib),leftovr
2743         format (1x,a1,a2,i4)
         else
            write (molname,2741) names(ia),names(ib),leftovr
2741         format (2a2,i4)
         endif
         if (iunits .eq. 1) then
            write (nwrite,2744) j,1.d-4*swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else if (iunits .eq. 2) then
            write (nwrite,2742) j,1.d8/swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else
            write (nwrite,2742) j,swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         endif
2742      format (i3,f10.3,2x,a8,f7.1,f8.2,1pe11.3,e11.3,e11.2)             
2744      format (i3,f10.6,2x,a8,f7.1,f8.2,1pe11.3,e11.3,e11.2)             
      endif
2710   continue
2704   if(ipr(3) .ge. 2) go to 4                                           
       return

28    if (ifresh .eq.0) then
         write (ndump,2811) obsitle,moditle
2811     format (a80)
c AMcW 8/2003
c        ifresh = 1
      endif
c     write (*,2804)
2804  format (/'Equivalent Widths Results '
     .     /'wavelength        EP     logGF     ident',
     .     '     Abund    EWcalc   Cont. Flux')
      write (ndump,2804)
      do l=lim1obs,lim2obs
         iatom = atom1(l)
         xab = dlog10(xabund(iatom)) + 12.
         ich = idint(charge(l) + 0.1)
         if (ich .eq. 1) then 
            ion = ' I  '
         elseif (ich .eq. 2) then
            ion = ' II '
         elseif (ich .eq. 3) then
            ion = ' III'
         endif
         if (iatom .lt. 100) then
c           write (*,2801) wave1(l),e(l,1),dlog10(gf(l)),names(iatom),
c    .           ion,xab,1000.*widout(l),cflux(l)
            write (ndump,2801) wave1(l),e(l,1),dlog10(gf(l)),
     .           names(iatom),ion,xab,1000.*widout(l),cflux(l)
 2801       format (f10.2,f10.2,f10.3,'     ',a2,a3,f10.2,f10.1,3x,
     .               1pe12.6)
         else
c           write (*,2802) wave1(l),e(l,1),dlog10(gf(l)),atom1(l),
c    .           xab,1000.*widout(l)
            write (ndump,2802) wave1(l),e(l,1),dlog10(gf(l)),atom1(l),
     .         xab,1000.*widout(l)
 2802       format (f10.2,f10.2,f10.3,a10,f10.2,f10.1)
         end if
      end do
      return

29    do 2910 l=lim1obs,lim2obs
         if (abunout(l).lt.999.) then
            ew = 1000.*width(l)
            rw = dlog10(width(l)/wave1(l))
            write (ndump,2901) lineid(l),wave1(l),e(l,1),dlog10(gf(l)),
     .         ew,abunout(l)
2901        format (a5,f10.3,f8.3,f8.3,f8.2,f8.3)
         endif
2910  continue

      return
      end                                                                


