
      real*8 function partfn (atom,jmark)                                  
c******************************************************************************
c     This routine computes arrays or single partition functions         
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      real*8 thpart(3,3), ndpart(3,6), uupart(3,6)
      data (ndpart(1,i),i=1,6)/ -3.69340716d+3,  2.07672551d+3,
     .                          -4.61061880d+2,  5.04289636d+1,
     .                          -2.70949776d+0,  5.70499143d-2/
      data (ndpart(2,i),i=1,6)/ -6.14001006d+3,  3.43797948d+3,
     .                          -7.68130434d+2,  8.55970362d+1,
     .                          -4.75533573d+0,  1.05363768d-1/
      data (ndpart(3,i),i=1,6)/ -8.98340934d+2,  4.95993575d+2,
     .                          -1.09861091d+2,  1.21995868d+1,
     .                          -6.77229656d-1,  1.50250139d-2/
      data (uupart(1,i),i=1,6)/ -7.80733849d+2,  4.15269002d+2,
     .                          -8.50971724d+1,  8.30809555d+0,
     .                          -3.77141610d-1,  6.08341139d-3/
      data (uupart(2,i),i=1,6)/  1.20793703d+2, -1.30861494d+2,
     .                           4.48063653d+1, -6.84490372d+0,
     .                           4.88529516d-1, -1.32730303d-2/
      data (uupart(3,i),i=1,6)/  5.18480529d+3, -3.02564444d+3,
     .                           7.03396006d+2, -8.14028851d+1,
     .                           4.68959696d+0, -1.07563314d-1/
      data (thpart(1,i),i=1,3)/ 14.66, 35.40, 77.35/
      data (thpart(2,i),i=1,3)/ 19.57, 45.90, 87.64/
      data (thpart(3,i),i=1,3)/ 35.22, 56.02, 77.97/

      if (int(atom).eq.60 .or. int(atom).eq.92) go to 10
      if (int(atom) .eq. 90) go to 20

c*****do a single partition function just for the molecular equilibrium
      if (jmark .gt. 500) then
         partfn = ucalc(atom,jmark)                                         
         return                                                             

c*****do partition functions for 4 ionization states of an element
      else
         iat = 10*idint(atom) - 1
         at = dfloat(iat)/10.
         do k=1,4
            iat = iat + 1
            at = dfloat(iat)/10.
            do i=1,ntau   
               u(jmark,k,i) = ucalc(at,i)   
            enddo
         enddo
      endif
      return                                                             

c*****for Neodynium and Uranium, override the partition functions of ATLAS.
c     this is a special code for these partition functions;
c     it is taken from Irwin, 1981, ApJS, 45, 621
10    do k=1,3
         do i=1,ntau
            ulog = 0.
            tlog = dlog(t(i))
            do j=1,6
               if (int(atom) .eq. 60) then
                  ulog = ulog + ndpart(k,j)*tlog**(j-1)
               else
                  ulog = ulog + uupart(k,j)*tlog**(j-1)
               endif
            enddo
            u(jmark,k,i) = exp(ulog)
         enddo
      enddo
      do i=1,ntau
         u(jmark,4,i) = 1.0
      enddo
      if (ipr(3) .ge. 4) write (nwrite,1004)
1004  format (/'THERE ARE SPECIAL PARTITION FUNCTIONS ',
     .         'FOR NEODYNIUM OR URANIUM')                   
      return


c*****for Thorium, override the partition functions of ATLAS.
c     this is a special code for the Thorium partition functions;
c     it is taken from Morell et al. 1992, A&A 259, 543
20    do k=1,3
         do i=1,ntau
            if (t(k) .le. 3600.) then
               u(jmark,k,i) = thpart(k,1)
            elseif (t(k) .le. 5700.) then
               frac = (t(i)-3600.)/2100.
               u(jmark,k,i) = thpart(k,1) + 
     .                        frac*(thpart(k,2)-thpart(k,1))
            elseif (t(k) .le. 8000.) then
               frac = (t(i)-5700.)/2300.
               u(jmark,k,i) = thpart(k,2) + 
     .                        frac*(thpart(k,3)-thpart(k,2))
            else
               frac = 1.0 + (t(i)-8000.)/8000.
               u(jmark,k,i) = frac*thpart(k,3)
            endif
         enddo
      enddo
      do i=1,ntau
         u(jmark,4,i) = 1.0
      enddo
      if (ipr(3) .ge. 4) write (nwrite,1001)
1001  format (/'THERE ARE SPECIAL PARTITION FUNCTIONS ',
     .         'FOR THORIUM')                   
      return


      end                                                                




