
      subroutine pltspec (line)
c******************************************************************************
c     This subroutine controls the plotting of the synthesized and 
c     observed data
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 xnum
      integer sm_device
      character*1 choice, deviations
c     real*4 xpos,ypos,yyadd,xxadd,vvmult,yymult  AMcW 1/2000
      real*8 xpos,ypos,yyadd,xxadd,vvmult,yymult


c  initialize some variables
      if(iscale .eq. 0) then
         ymult = 1.
         ylo = 0.
         yhi = 1.1
         xlo = 0.
         xhi = 0.
         choice = 's'
         deviations = 'n'
      else
         choice = '1'
         deviations = 'n'
      endif

c  begin by reading in an observed spectrum
      if (ipr(9) .ge. 1 .and. ipr(7) .ge. 2) then
         call readobs (line)
         if (lount .eq. -1) then
            array = 'OBSERVED SPECTRUM FILE PROBLEM!  I QUIT.'
            istat = ivwrite (13,3,array,40)
            return
         endif
      endif
      
      istat = ivcleof(4,1)

c  go through the option list:  the routine may be exited
1     if (choice .eq. 'q') then
         return

      elseif (choice .eq. '1' .or. choice .eq. '2') then
         call smooth (-1)
         wmiddle = (start + stop)/2.
         do i=1,lount
            yobs(i) = ymult*yobs(i)
            yobs(i) = yadd+yobs(i)
            xobs(i) = xadd+xobs(i)
            xobs(i) = vmult*wmiddle/2.99795e+5 + xobs(i)
         enddo
         if (ymult .eq. 0.0) ymult = 1.0
         if (xlo .eq. xhi) then
            xlo = start
            xhi = stop
         endif
         if (ylo .eq. yhi) then
            ylo = 0.
            yhi = 1.1
            
         endif
         
c  or the synthetic spectra may be resmoothed
      elseif (choice .eq. 's') then
2        write (array,1007)
1007     format ('SMOOTHING: n=NONE, g=GAUSS, l=LORENZ, ',
     .           'v=ROTATION, m=MACROTURBULENCE')
         istat = ivwrite (line+4,3,array,67)
         write (array,1008)
1008     format ('           c=v+g, d=m+g, r=m+v+g, p=VARIABLE GAUSS')
         istat = ivwrite (line+5,3,array,50)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+6)
         smtype = chinfo(1:1)
            call smooth (line+7)
         if (smtype.eq.'n' .or. smtype.eq.'g' .or.
     .       smtype.eq.'l' .or. smtype.eq.'v' .or.
     .       smtype.eq.'m' .or. smtype.eq.'c' .or.
     .       smtype.eq.'d' .or. smtype.eq.'r') then
         elseif (smtype .eq. 'p') then
            call vargauss (line+7)
         else
            go to 2
         endif
         if (smtype .eq. 'e') then
            array = 'REDO THE SMOOTHING (y/n)? '
            nchars = 26
            call getasci (nchars,line+9)
            smtype = chinfo(1:1)
            if (smtype .eq. 'n') then
               go to 100
            else
               istat = ivcleof (10,1)
               go to 2
            endif
         endif
         if (xlo .eq. 0.0 .and. xhi .eq. 0.0) then
            xlo = start
            xhi = stop
         endif

c  or the observations may be rescaled
      elseif (choice .eq. 'r') then
         array = 'MULTIPLY THE OBSERVED POINTS BY WHAT FACTOR? '
         nchars = 45
         call getasci (nchars,13)
         call number (nchars,10,xnum)
         yymult = sngl(xnum)
         ymult = ymult + yymult
         do i=1,lount
            yobs(i) = yymult*yobs(i)
         enddo

c  or the observations may be shifted by an additive constant
      elseif (choice .eq. 'a') then
         array = 'ADD WHAT NUMBER TO THE OBSERVED POINTS? '
         nchars = 40
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         yyadd = sngl(xnum)
         yadd = yadd + yyadd
         do i=1,lount
            yobs(i) = yyadd + yobs(i)
         enddo

c  or the observations may be shifted by a constant wavelength
      elseif (choice .eq. 'w') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT WAVELENGTH? '
         nchars = 46
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         xxadd = sngl(xnum)
         xadd = xadd + xxadd
         do i=1,lount
            xobs(i) = xxadd + xobs(i)
         enddo

c  or the observations may be shifted by a constant velocity
      elseif (choice .eq. 'v') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT VELOCITY (KM/S)? '
         nchars = 51
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         vvmult = sngl(xnum)
         vmult = vmult * vvmult
         wmiddle = (start + stop)/2.
         do i=1,lount
            xobs(i) = vvmult*wmiddle/2.99795e+5 + xobs(i)
         enddo

c  or the plot boundaries may be changed
      elseif (choice .eq. 'c') then
         write (array,1001) xlo
1001     format ('LEFT WAVELENGTH (',f9.2,'): ')
         nchars = 29
         call getasci (nchars,15)
         if (nchars .gt. 0) then
            call number (nchars,15,xnum)
            xlo = sngl(xnum)
         endif
         write (array,1002) xhi
1002     format ('RIGHT WAVELENGTH (',f9.2,'): ')
         nchars = 30
         call getasci (nchars,16)
         if (nchars .gt. 0) then
            call number (nchars,16,xnum)
            xhi = sngl(xnum)
         endif
         write (array,1003) ylo
1003     format ('BOTTOM RELATIVE FLUX (',f9.2,'): ')
         nchars = 34
         call getasci (nchars,17)
         if (nchars .gt. 0) then
            call number (nchars,17,xnum)
            ylo = sngl(xnum)
         endif
         write (array,1004) yhi
1004     format ('TOP RELATIVE FLUX (',f9.2,'): ')
         nchars = 31
         call getasci (nchars,18)
         if (nchars .gt. 0) then
            call number (nchars,18,xnum)
            yhi = sngl(xnum)
         endif
         go to 121

c    use the cross hairs to zoom in on a particular feature
      elseif (choice .eq. 'z') then
         call sm_graphics
         if (deviations .eq. 'y') then
            call sm_window (1,2,1,1,1,1)
         endif
         array = 'MARK THE LOWER LEFT HAND CORNER WITH THE CURSOR'
 220     istat = ivcleof(13,1)
         istat = ivwrite(13,3,array,47)
         call sm_curs (xlo,ylo,ichr)
         array = 'MARK THE UPPER RIGHT HAND CORNER WITH THE CURSOR'
 212     istat = ivcleof(14,1)
         istat = ivwrite (14,1,array,48)
         call sm_curs (xhi,yhi,ichr)
         call sm_gflush
         call sm_alpha

 121     do 16 i=1,lount
            if (xlo .le. xobs(i)) go to 17
16          continue
         lim1obs = 1
         go to 19
17       lim1obs = i
19       do 18 i=lim1obs,lount
            if (xhi .le. xobs(i)) go to 14
18          continue
c        go to 13   AMcW 1/2000
         lim1obs = 1
         lim2obs = lount
         deviations = 'n'

14       lim2obs = i

c    return cursor position
      elseif (choice .eq. 'p') then
         call sm_graphics
         if (deviations .eq. 'y') then
            call sm_window (1,2,1,1,1,1)
         endif
         array = 'MARK THE POSITION WITH THE CURSOR'
 213     istat=ivcleof(21,1)
         istat=ivwrite(13,3,array,34)
         call sm_curs (xpos,ypos,ichr)
         call sm_relocate (xpos,ypos-0.05d0*(yhi-ylo))
         call sm_draw (xpos,ypos+0.05d0*(yhi-ylo))
         call sm_draw (xpos-0.01d0*(xhi-xlo),ypos+0.04d0*(yhi-ylo))
         call sm_relocate (xpos,ypos+0.05d0*(yhi-ylo))
         call sm_draw (xpos+0.01d0*(xhi-xlo),ypos+0.04d0*(yhi-ylo))
         write (array,1041) xpos
1041     format (f8.2)
         call sm_relocate (xpos,ypos-0.07d0*(yhi-ylo))
         call sm_putlabel (5,array)
         call sm_gflush
         call sm_alpha
         go to 100

c    change the title of the model....
      elseif (choice .eq. 't') then
         array = 'ENTER THE NEW TITLE'
         istat = ivcleof(21,1)
         istat = ivwrite (13,3,array,19)
         read (*,33) moditle
 33      format(a80)
   
c    replot the spectra with a separate plot for observed/synthtic deviations
      elseif (choice .eq. 'd') then
         deviations = 'y'

c    the plot boundaries may be reset to the original values;
c    this is a basic starting over plot
c 13  elseif (choice .eq. 'o') then  removed AMcW 1/2000
13    elseif (choice .eq. 'o') then
         xlo = start
         xhi = stop
         ylo = 0.
         yhi = 1.1
         lim1obs = 1
         lim2obs = lount
         deviations = 'n'

c    the plot boundaries may be reset to the original values
      elseif (choice .eq. 'm') then
         go to 90

c    now either here make a hardcopy plot
      elseif (choice .eq. 'h') then
         if (sm_device('postland') .lt. 0) then
            write (nwrite,1009)
1009        format ('DEVICE OPENING ERROR FOR: postland')
            stop
         endif
         call sm_graphics
         call sm_erase
         call synplot (choice,deviations)
         call sm_gflush
         call sm_alpha
         call sm_hardcopy
         go to 100

c    or write the plot to a postscript file
      elseif (choice .eq. 'f') then
         array = 'Give the file name for the POSTSRIPT plot image: '
         nchars = 49
         call getasci (nchars,13)
         write (array,1005) chinfo(1:nchars)
1005     format ('postlandfile ',a67)
         if (sm_device(array(1:nchars+9)) .lt. 0) then
            write (nwrite,1006) array(1:nchars+9)
1006        format ('FILE OPENING ERROR FOR:',a56)
            stop
         endif
         call sm_graphics
         call sm_erase
         call synplot (choice,deviations)
         call sm_gflush
         call sm_alpha
         call sm_hardcopy
         go to 100
      
c   or rerun the model with new abundances
      elseif (choice .eq. 'n') then
         call chabund
         call smooth (-1)
         choice = 'm'
         go to 1

c   or reprint the option table if the choice is not understood
      else 
         go to 100
      endif
      
c    or plot on the terminal
90    if (sm_device(smterm) .lt. 0) then
         write (nwrite,1010) smterm
1010     format ('DEVICE OPENING ERROR FOR:',a54)
         stop
      endif
      call sm_graphics
      call sm_erase
      call synplot (choice,deviations)
      call sm_gflush
      call sm_alpha
      
c     finally, print the option table and loop back  
100   istat = ivcleof (5,1)
      array = 'OPTIONS?    s=new smoothing     r=rescale obs.     '
      istat = ivwrite (5,3,array,48)
      array = '            a=add # to obs.     h=hardcopy         '
      istat = ivwrite (6,3,array,48)
      array = '            c=change bounds     q=quit             '
      istat = ivwrite (7,3,array,48)
      array = '            m=redo same plot    o=orig. plot bounds'
      istat = ivwrite (8,3,array,51)
      array = '            v=velocity shift    w=wavelength shift '
      istat = ivwrite (9,3,array,51)
      array = '            z=zoom in on plot   p=cursor position  '
      istat = ivwrite (10,3,array,51)
      array = '            t=change title      f=postscript file  '
      istat = ivwrite (11,3,array,51)
      array = '            n=new abundances    d=obs/syn deviation'
      istat = ivwrite (12,3,array,51)
      array = 'What is your choice? '
      nchars = 21
      call getasci (nchars,14)
      choice = chinfo(1:1)
      go to 1

      end
      




