
      subroutine synplot (choice,deviations)
c******************************************************************************
c     This routine produces MONGO plots of the syntheses.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Quants.com'
      include 'Factor.com'
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
c     real*4 style(1)  AMcW 1/2000
c     real*4 yup,ydown  AMcW 1/2000
      real*8 style(1)
      real*8 yup,ydown
      character*1 choice, deviations
      integer iflip
      character*7 colors(8)


c*****assign colors to character arrays
      colors(1) = 'white  '
      colors(2) = 'red    '
      colors(3) = 'blue   '
      colors(4) = 'yellow '
      colors(5) = 'green  '
      colors(6) = 'cyan   '
      colors(7) = 'magenta'
      colors(8) = 'black  '
 

c*****define the plot limits
      if(xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the spectra
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype (colors(8))
      else
         call sm_ctype (colors(1))
      endif
      if (deviations .eq. 'n') then
         call sm_window (1,1,1,1,1,1)
      else
         call sm_window (1,2,1,1,1,1)
      endif
      call sm_box (1,2,0,0)
      if (iflip .eq. 1) then
         array = 'Wavenumber'
      else
         array = 'Wavelength'
      endif
      call sm_xlabel (array)
      array = 'Rel  Flux'
      call sm_ylabel (array)
      call sm_expand (0.9d0)
      call sm_lweight (1.4d0)
      

c*****plot the synthetic spectra
      do i=1,100
         if (pec(i) .ne. 0) go to 111
      enddo            
111   do j=1,nsyn
         if (choice.eq.'h' .or. choice.eq.'f') then
            call sm_ctype (colors(8))
            call sm_ltype (j-1)
         else
            if (smterm.eq.'x11' .or. smterm.eq.'X11') then
               call sm_ctype (colors(j+1))
               call sm_ltype (0)
            else
               call sm_ctype (colors(1))
               call sm_ltype (j-1)
            endif
         endif
         call sm_conn (xsyn,chunk(1,j),kount) 
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.045d0*(xlo-xhi),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_draw (xhi+0.005d0*(xlo-xhi),
     .                 ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_relocate (xhi+0.05d0*(xlo-xhi),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
         else
            call sm_relocate (xlo+0.045d0*(xhi-xlo),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_draw (xlo+0.005d0*(xlo-xhi),
     .                 ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_relocate (xlo+0.05d0*(xhi-xlo),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
         endif
         noff = 80*(j-1)
         call sm_label (abitle(noff+1:noff+80))
      end do
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype (colors(8))
      else
         call sm_ctype (colors(1))
      endif
      call sm_ltype (0)

   
c*****plot the observed spectrum
      if (ipr(7) .eq. 2) then
         call sm_lweight (2.2d0)
         mount = lim2obs - lim1obs + 1
         if (mount .lt. 1000) then
            style(1) = 43.0d0
            call sm_ptype (style,1)
            call sm_points (xobs(lim1obs),yobs(lim1obs),mount)
         else
            call sm_conn (xobs(lim1obs),yobs(lim1obs),mount)
         endif
         call sm_lweight (1.0d0)
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.05d0*(xlo-xhi),ylo+0.08d0*(yhi-ylo))
         else
            call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.08d0*(yhi-ylo))
         endif
         call sm_label (obsitle)
      endif
      if (iflip .eq. 1) then
         call sm_relocate (xhi+0.05d0*(xlo-xhi),ylo+0.04d0*(yhi-ylo))
      else
         call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.04d0*(yhi-ylo))
      endif
      call sm_label (moditle)
      if (deviations .eq. 'n' .or. ipr(7) .ne. 2) return
 

c*****this section of code is executed only if a deviations plot is desired;
c     find the starting and stopping points in the arrays for the deviations
      if (xsyn(kount) .le. xobs(lim1obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim2obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim1obs)) go to 150
      lim3obs = lim1obs
      do k=2,kount
         if (xsyn(k) .gt. xobs(lim3obs)) then
            lim1syn = k - 1
            go to 155
         endif
      enddo
150   lim1syn = 1
      do l=lim1obs,lim2obs
         if (xsyn(lim1syn) .le. xobs(l)) then
            lim3obs = l 
            go to 155
         endif
      enddo
155   if (xsyn(kount) .lt. xobs(lim2obs)) go to 160
      lim4obs = lim2obs
      do k=lim1syn,kount
         if (xsyn(k) .gt. xobs(lim4obs)) then
            lim2syn = k
            go to 165
         endif
      enddo
160   lim2syn = kount
      do l=lim3obs,lim2obs
         if (xsyn(lim2syn) .lt. xobs(l)) then
            lim4obs = l - 1
            go to 165
         endif
      enddo


c  compute the deviations; linear interpolation in the wavelength array
c  of the synthetic spectra is considered sufficient
165   do j=1,nsyn
         lpoint = lim1syn
         devsigma = 0.
         do i=lim3obs,lim4obs
170         if (xsyn(lpoint+1) .lt. xobs(i)) then
               lpoint = lpoint + 1
               go to 170
            endif
            syninterp = (chunk(lpoint+1,j)-chunk(lpoint,j))*
     .         (xobs(i)-xsyn(lpoint))/(xsyn(lpoint+1)-xsyn(lpoint)) +
     .         chunk(lpoint,j)
            dev(i) = yobs(i) - syninterp
            devsigma = devsigma + dev(i)**2
         enddo
         devsigma = dsqrt(devsigma/(lim4obs-lim3obs-1))
         
      
c  from first set of deviations, define the plot limits, draw and label box
         if (j .eq. 1) then
            yup = -1000.
            ydown = +1000.
            do i=lim3obs,lim4obs
               yup = dmax1(yup,dev(i))
               ydown = dmin1(ydown,dev(i))
            enddo
            ydelta = dmin1(0.3d0,dmax1(0.05d0,1.5d0*(yup-ydown)/2.d0))
            ydown = -ydelta
            yup = ydelta
            call sm_limits (xlo,xhi,ydown,yup)
            call findtic (ydown,yup,bigytic,smlytic)
            call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
            call sm_expand (1.2d0)
            call sm_lweight (1.8d0)
            if (choice.eq.'h' .or. choice.eq.'f') then
               call sm_ctype (colors(8))
            else
               call sm_ctype (colors(1))
            endif
            call sm_window (1,2,1,2,1,2)
            call sm_box (0,2,0,0)
            array = 'Obs - Comp'
            call sm_ylabel (array)
            call sm_relocate (xlo,0.0d0)
            call sm_draw (xhi,0.0d0)
            call sm_expand (0.9d0)
         endif


c  plot the array of deviations
180      if (choice.eq.'h' .or. choice.eq.'f') then
            call sm_ctype (colors(8))
            call sm_ltype (j-1)
         else
            if (smterm.eq.'x11' .or. smterm.eq.'X11') then
               call sm_ctype (colors(j+1))
               call sm_ltype (0)
            else
               call sm_ctype (colors(1))
               call sm_ltype (j-1)
            endif
         endif
         call sm_conn (xobs(lim1obs),dev(lim1obs),mount)
         write (array,1021) devsigma
1021     format ('sigma =',f6.3)
         call sm_relocate(xhi-0.2d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_relocate(xhi-0.24d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_draw(xhi-0.215d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_label (array)
      enddo


c  reset the spectrum plot boundaries before exiting
      if(xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif


1000  return
      end






